Index: codes/icosagcm/trunk/src/advect.f90
===================================================================
--- codes/icosagcm/trunk/src/advect.f90	(revision 150)
+++ codes/icosagcm/trunk/src/advect.f90	(revision 151)
@@ -53,4 +53,5 @@
   SUBROUTINE compute_gradq3d(qi,one_over_sqrt_leng,gradq3d)
     USE trace
+    USE omp_para
     IMPLICIT NONE
     REAL(rstd),INTENT(IN)  :: qi(iim*jjm,llm)
@@ -72,5 +73,5 @@
     ! Compute gradient at triangles solving a linear system
     ! arr = area of triangle joining centroids of hexagons
-    Do l = 1,llm 
+     DO l = ll_begin,ll_end 
        DO j=jj_begin-1,jj_end+1
           DO i=ii_begin-1,ii_end+1
@@ -90,5 +91,5 @@
       
     DO k=1,3
-      DO l =1,llm
+      DO l =ll_begin,ll_end
         DO j=jj_begin,jj_end
            DO i=ii_begin,ii_end
@@ -103,6 +104,5 @@
 
     !============================================================================================= LIMITING 
-    ! GO TO 120 
-    DO l =1,llm
+    DO l =ll_begin,ll_end
        DO j=jj_begin,jj_end
           DO i=ii_begin,ii_end
@@ -110,9 +110,4 @@
              maggrd =  dot_product(gradq3d(n,l,:),gradq3d(n,l,:))
              maggrd = sqrt(maggrd) 
-!             leng = max(sum((xyz_v(n+z_up,:) - xyz_i(n,:))**2),sum((xyz_v(n+z_down,:) - xyz_i(n,:))**2), &
-!                  sum((xyz_v(n+z_rup,:) - xyz_i(n,:))**2),sum((xyz_v(n+z_rdown,:) - xyz_i(n,:))**2),  &
-!                  sum((xyz_v(n+z_lup,:) - xyz_i(n,:))**2),sum((xyz_v(n+z_ldown,:) - xyz_i(n,:))**2))
-!             maxq_c = qi(n,l) + maggrd*sqrt(leng(n))
-!             minq_c = qi(n,l) - maggrd*sqrt(leng(n))
              maxq_c = qi(n,l) + maggrd*one_over_sqrt_leng(n)
              minq_c = qi(n,l) - maggrd*one_over_sqrt_leng(n)
@@ -137,4 +132,5 @@
   SUBROUTINE compute_backward_traj(normal,tangent,ue,tau, cc)
     USE trace
+    USE omp_para
     IMPLICIT NONE
     REAL(rstd),INTENT(IN)    :: normal(3*iim*jjm,3)
@@ -152,5 +148,5 @@
     
     ! reconstruct tangential wind then 3D wind at edge then cc = edge midpoint - u*tau
-    DO l = 1,llm
+    DO l = ll_begin,ll_end
        DO j=jj_begin-1,jj_end+1
           DO i=ii_begin-1,ii_end+1
@@ -213,4 +209,5 @@
   SUBROUTINE compute_advect_horiz(update_mass,hfluxt,cc,gradq3d, mass,qi) 
     USE trace
+    USE omp_para
     IMPLICIT NONE
     LOGICAL, INTENT(IN)       :: update_mass
@@ -230,5 +227,5 @@
     ! q(cc)= q0 + gradq.(cc-xyz_i)  with xi centroid of hexagon
     ! ne*hfluxt>0 iff outgoing
-    DO l = 1,llm
+    DO l = ll_begin,ll_end
        DO j=jj_begin-1,jj_end+1
           DO i=ii_begin-1,ii_end+1
@@ -265,5 +262,5 @@
 
     ! update q and, if update_mass, update mass
-    DO l = 1,llm
+    DO l = ll_begin,ll_end
        DO j=jj_begin,jj_end
           DO i=ii_begin,ii_end
Index: codes/icosagcm/trunk/src/advect_tracer.f90
===================================================================
--- codes/icosagcm/trunk/src/advect_tracer.f90	(revision 150)
+++ codes/icosagcm/trunk/src/advect_tracer.f90	(revision 151)
@@ -9,6 +9,14 @@
   TYPE(t_field),POINTER :: f_cc(:)  ! starting point of backward-trajectory (Miura approach)
   TYPE(t_field),POINTER :: f_one_over_sqrt_leng(:)
- 
+
+  TYPE(t_message) :: req_u, req_wfluxt, req_q, req_rhodz, req_gradq3d
+
   REAL(rstd), PARAMETER :: pente_max=2.0 ! for vlz
+
+! temporary shared variable for vlz
+  TYPE(t_field),POINTER :: f_dzqw(:)   ! vertical finite difference of q 
+  TYPE(t_field),POINTER :: f_adzqw(:)  ! abs(dzqw)
+  TYPE(t_field),POINTER :: f_dzq(:)    ! limited slope of q
+  TYPE(t_field),POINTER :: f_wq(:)     ! time-integrated flux of q
 
   PUBLIC init_advect_tracer, advect_tracer
@@ -28,5 +36,9 @@
     CALL allocate_field(f_cc,field_u,type_real,llm,3, name='cc')
     CALL allocate_field(f_one_over_sqrt_leng,field_t,type_real, name='one_over_sqrt_leng')
-
+    CALL allocate_field(f_dzqw, field_t, type_real, llm, name='dzqw')
+    CALL allocate_field(f_adzqw, field_t, type_real, llm, name='adzqw')
+    CALL allocate_field(f_dzq, field_t, type_real, llm, name='dzq')
+    CALL allocate_field(f_wq, field_t, type_real, llm+1, name='wq')
+    
     DO ind=1,ndomain
        CALL swap_dimensions(ind)
@@ -56,47 +68,36 @@
     REAL(rstd),POINTER :: hfluxt(:,:), wfluxt(:,:)
     REAL(rstd),POINTER :: rhodz(:,:), u(:,:) 
-    INTEGER :: ind,k
+! temporary shared variable for vlz
+    REAL(rstd),POINTER ::  dzqw(:,:)         ! vertical finite difference of q 
+    REAL(rstd),POINTER ::  adzqw(:,:)        ! abs(dzqw)
+    REAL(rstd),POINTER ::  dzq(:,:)          ! limited slope of q
+    REAL(rstd),POINTER ::  wq(:,:)           ! time-integrated flux of q
+    
+     INTEGER :: ind,k
+    LOGICAL,SAVE :: first=.TRUE.
+!$OMP THREADPRIVATE(first)
+
+    IF (first) THEN
+      first=.FALSE.
+      CALL init_message(f_u,req_e1_vect,req_u)
+      CALL init_message(f_wfluxt,req_i1,req_wfluxt)
+      CALL init_message(f_q,req_i1,req_q)
+      CALL init_message(f_rhodz,req_i1,req_rhodz)
+      CALL init_message(f_gradq3d,req_i1,req_gradq3d)
+    ENDIF
+    
+!$OMP BARRIER
 
     CALL trace_start("advect_tracer") 
 
-    CALL transfert_request(f_u,req_e1_vect)
-!    CALL transfert_request(f_hfluxt,req_e1)  ! BUG : This (unnecessary) transfer makes the computation go wrong
-    CALL transfert_request(f_wfluxt,req_i1)
-    CALL transfert_request(f_q,req_i1)
-    CALL transfert_request(f_rhodz,req_i1)
-	
-!    IF (is_mpi_root) PRINT *, 'Advection scheme'
-
-!    DO ind=1,ndomain
-!       CALL swap_dimensions(ind)
-!       CALL swap_geometry(ind)
-!       normal  = f_normal(ind)
-!       tangent = f_tangent(ind)
-!       cc      = f_cc(ind)
-!       u       = f_u(ind)
-!       q       = f_q(ind)
-!       rhodz   = f_rhodz(ind)
-!       hfluxt  = f_hfluxt(ind) 
-!       wfluxt  = f_wfluxt(ind) 
-!       gradq3d = f_gradq3d(ind)
-!
-!       ! 1/2 vertical transport
-!       DO k = 1, nqtot
-!          CALL vlz(k==nqtot,0.5, wfluxt,rhodz,q(:,:,k))
-!       END DO
-!
-!       ! horizontal transport
-!       CALL compute_backward_traj(tangent,normal,u,0.5*dt*itau_adv, cc) 
-!       DO k = 1,nqtot
-!          CALL compute_gradq3d(q(:,:,k),gradq3d)
-!          CALL compute_advect_horiz(k==nqtot,hfluxt,cc,gradq3d, rhodz,q(:,:,k))
-!       END DO
-!
-!       ! 1/2 vertical transport
-!       DO k = 1,nqtot
-!          CALL vlz(k==nqtot, 0.5,wfluxt,rhodz, q(:,:,k))
-!       END DO
-!    END DO
-
+    CALL send_message(f_u,req_u)
+    CALL send_message(f_wfluxt,req_wfluxt)
+    CALL send_message(f_q,req_q)
+    CALL send_message(f_rhodz,req_rhodz)
+    CALL wait_message(req_u)
+    CALL wait_message(req_wfluxt)
+    CALL wait_message(req_q)
+    CALL wait_message(req_rhodz)
+    
     ! 1/2 vertical transport + back-trajectories
     DO ind=1,ndomain
@@ -110,17 +111,20 @@
        rhodz   = f_rhodz(ind)
        wfluxt  = f_wfluxt(ind) 
+       dzqw    = f_dzqw(ind)
+       adzqw   = f_adzqw(ind)
+       dzq     = f_dzq(ind)
+       wq      = f_wq(ind) 
 
        DO k = 1, nqtot
-          CALL vlz(k==nqtot,0.5, wfluxt,rhodz,q(:,:,k),1)
+          CALL vlz(k==nqtot,0.5, wfluxt,rhodz,q(:,:,k),1,dzqw, adzqw, dzq, wq)
        END DO
 
        CALL compute_backward_traj(tangent,normal,u,0.5*dt*itau_adv, cc) 
-    END DO
-
-!    CALL transfert_request(f_q,req_i1)      ! necessary ?
-!    CALL transfert_request(f_rhodz,req_i1)  ! necessary ?
+
+    END DO
+
 
     ! horizontal transport - split in two to place transfer of gradq3d
-
+!$OMP BARRIER
     DO k = 1, nqtot
        DO ind=1,ndomain
@@ -133,6 +137,6 @@
        END DO
 
-       CALL transfert_request(f_gradq3d,req_i1)
-
+       CALL send_message(f_gradq3d,req_gradq3d)
+       CALL wait_message(req_gradq3d)
 
 
@@ -149,8 +153,7 @@
     END DO 
     
-!    CALL transfert_request(f_q,req_i1)      ! necessary ?
-!    CALL transfert_request(f_rhodz,req_i1)  ! necessary ?
-    
     ! 1/2 vertical transport
+!$OMP BARRIER
+
     DO ind=1,ndomain
        CALL swap_dimensions(ind)
@@ -159,14 +162,22 @@
        rhodz   = f_rhodz(ind)
        wfluxt  = f_wfluxt(ind) 
+       dzqw    = f_dzqw(ind)
+       adzqw   = f_adzqw(ind)
+       dzq     = f_dzq(ind)
+       wq      = f_wq(ind) 
+
        DO k = 1,nqtot
-          CALL vlz(k==nqtot, 0.5,wfluxt,rhodz, q(:,:,k),0)
+          CALL vlz(k==nqtot, 0.5,wfluxt,rhodz, q(:,:,k),0, dzqw, adzqw, dzq, wq)
        END DO
+
     END DO
 
     CALL trace_end("advect_tracer")
 
+!$OMP BARRIER
+
   END SUBROUTINE advect_tracer
 
-  SUBROUTINE vlz(update_mass, fac,wfluxt,mass, q, halo)
+  SUBROUTINE vlz(update_mass, fac,wfluxt,mass, q, halo, dzqw, adzqw, dzq, wq)
     !
     !     Auteurs:   P.Le Van, F.Hourdin, F.Forget, T. Dubos
@@ -178,4 +189,5 @@
     !    ********************************************************************
     USE trace
+    USE omp_para
     IMPLICIT NONE
     LOGICAL, INTENT(IN)       :: update_mass
@@ -185,9 +197,11 @@
     INTEGER, INTENT(IN) :: halo
 
-    REAL(rstd) :: dq(iim*jjm,llm), & ! increase of q
-         dzqw(iim*jjm,llm),        & ! vertical finite difference of q 
-         adzqw(iim*jjm,llm),       & ! abs(dzqw)
-         dzq(iim*jjm,llm),         & ! limited slope of q
-         wq(iim*jjm,llm+1)           ! time-integrated flux of q
+! temporary shared variable
+    REAL(rstd),INTENT(INOUT) :: dzqw(iim*jjm,llm),        & ! vertical finite difference of q 
+                                adzqw(iim*jjm,llm),       & ! abs(dzqw)
+                                dzq(iim*jjm,llm),         & ! limited slope of q
+                                wq(iim*jjm,llm+1)           ! time-integrated flux of q
+
+
     REAL(rstd) :: dzqmax, newmass, sigw, qq, w
     INTEGER :: i,ij,l,j
@@ -196,5 +210,6 @@
 
     ! finite difference of q
-    DO l=2,llm
+
+     DO l=ll_beginp1,ll_end
        DO j=jj_begin-halo,jj_end+halo
           DO i=ii_begin-halo,ii_end+halo
@@ -206,7 +221,11 @@
     ENDDO
 
+!--> flush dzqw, adzqw
+!$OMP BARRIER
+
     ! minmod-limited slope of q
     ! dzq = slope*dz, i.e. the reconstructed q varies by dzq inside level l
-    DO l=2,llm-1
+
+     DO l=ll_beginp1,ll_endm1
        DO j=jj_begin-halo,jj_end+halo
           DO i=ii_begin-halo,ii_end+halo
@@ -223,42 +242,69 @@
     ENDDO
 
+
     ! 0 slope in top and bottom layers
-    DO j=jj_begin-halo,jj_end+halo
-       DO i=ii_begin-halo,ii_end+halo
-          ij=(j-1)*iim+i
-          dzq(ij,1)=0.
+    IF (omp_first) THEN
+      DO j=jj_begin-halo,jj_end+halo
+         DO i=ii_begin-halo,ii_end+halo
+           ij=(j-1)*iim+i
+           dzq(ij,1)=0.
+         ENDDO
+      ENDDO
+    ENDIF
+      
+    IF (omp_last) THEN
+      DO j=jj_begin-halo,jj_end+halo
+         DO i=ii_begin-halo,ii_end+halo
           dzq(ij,llm)=0.
-       ENDDO
-    ENDDO
+         ENDDO
+      ENDDO
+    ENDIF
+
+!---> flush dzq
+!$OMP BARRIER  
 
     ! sigw = fraction of mass that leaves level l/l+1
     ! then amount of q leaving level l/l+1 = wq = w * qq
-    DO l = 1,llm-1
+     DO l=ll_beginp1,ll_end
        DO j=jj_begin-halo,jj_end+halo
           DO i=ii_begin-halo,ii_end+halo
              ij=(j-1)*iim+i
-             w = fac*wfluxt(ij,l+1)
+             w = fac*wfluxt(ij,l)
              IF(w>0.) THEN  ! upward transport, upwind side is at level l 
+                sigw       = w/mass(ij,l-1)
+                qq         = q(ij,l-1)+0.5*(1.-sigw)*dzq(ij,l-1) ! qq = q if sigw=1 , qq = q+dzq/2 if sigw=0
+             ELSE           ! downward transport, upwind side is at level l+1
                 sigw       = w/mass(ij,l)
-                qq         = q(ij,l)+0.5*(1.-sigw)*dzq(ij,l) ! qq = q if sigw=1 , qq = q+dzq/2 if sigw=0
-             ELSE           ! downward transport, upwind side is at level l+1
-                sigw       = w/mass(ij,l+1)
-                qq         = q(ij,l+1)-0.5*(1.+sigw)*dzq(ij,l+1) ! qq = q if sigw=-1 , qq = q-dzq/2 if sigw=0                
+                qq         = q(ij,l)-0.5*(1.+sigw)*dzq(ij,l) ! qq = q if sigw=-1 , qq = q-dzq/2 if sigw=0                
              ENDIF
-             wq(ij,l+1) = w*qq
+             wq(ij,l) = w*qq
           ENDDO
        ENDDO
     END DO
     ! wq = 0 at top and bottom
-    DO j=jj_begin-halo,jj_end+halo
-       DO i=ii_begin-halo,ii_end+halo
-          ij=(j-1)*iim+i
-          wq(ij,llm+1)=0.
-          wq(ij,1)=0.
-       ENDDO
-    END DO
+    IF (omp_first) THEN
+      DO j=jj_begin-halo,jj_end+halo
+         DO i=ii_begin-halo,ii_end+halo
+            ij=(j-1)*iim+i
+            wq(ij,1)=0.
+         ENDDO
+      END DO
+    ENDIF
+    
+    IF (omp_last) THEN
+      DO j=jj_begin-halo,jj_end+halo
+         DO i=ii_begin-halo,ii_end+halo
+            ij=(j-1)*iim+i
+            wq(ij,llm+1)=0.
+         ENDDO
+      END DO
+    ENDIF
+
+! --> flush wq
+!$OMP BARRIER
+
 
     ! update q, mass is updated only after all q's have been updated
-    DO l=1,llm
+    DO l=ll_begin,ll_end
        DO j=jj_begin-halo,jj_end+halo
           DO i=ii_begin-halo,ii_end+halo
Index: codes/icosagcm/trunk/src/caldyn.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn.f90	(revision 150)
+++ codes/icosagcm/trunk/src/caldyn.f90	(revision 151)
@@ -11,5 +11,4 @@
   USE icosa
   USE caldyn_gcm_mod, ONLY : init_caldyn_gcm=>init_caldyn
-  USE caldyn_gcm_opt_mod, ONLY : init_caldyn_gcm_opt=>init_caldyn
   USE caldyn_adv_mod, ONLY : init_caldyn_adv=>init_caldyn
   IMPLICIT NONE
@@ -21,6 +20,4 @@
       CASE('gcm')
         CALL init_caldyn_gcm
-      CASE('gcm_opt')
-        CALL init_caldyn_gcm_opt
       CASE('adv')
         CALL init_caldyn_adv
@@ -37,5 +34,4 @@
   USE icosa
   USE caldyn_gcm_mod, ONLY : caldyn_gcm=>caldyn
-  USE caldyn_gcm_opt_mod, ONLY : caldyn_gcm_opt=>caldyn
   USE caldyn_adv_mod, ONLY : caldyn_adv=>caldyn
   IMPLICIT NONE
@@ -56,7 +52,4 @@
         CALL caldyn_gcm(write_out,f_phis, f_ps, f_theta_rhodz, f_u, f_q, &
              f_hflux, f_wflux, f_dps, f_dtheta_rhodz, f_du)
-      CASE('gcm_opt')
-        CALL caldyn_gcm_opt(write_out,f_phis, f_ps, f_theta_rhodz, f_u, f_q, &
-             f_hflux, f_wflux, f_dps, f_dtheta_rhodz, f_du)
       CASE('adv')
         CALL caldyn_adv(write_out,f_phis, f_ps, f_theta_rhodz, f_u, f_q, &
